<template>
  <main role="main" class="pf-c-page__main" tabindex="-1" id="session-details">
    <section class="pf-c-page__main-section">
      <div class="pf-l-bullseye__item">
        <div class="pf-c-card">
          <div id="header-title" class="pf-c-card__header pf-c-title pf-m-2xl">
            Session Details
          </div>
          <div class="pf-c-card__body">
            <form novalidate class="pf-c-form" @submit="save">
              <div class="pf-c-form__group">
                <label
                  class="pf-c-form__label"
                  for="help-text-simple-form-name"
                >
                  <span class="pf-c-form__label-text">Name</span>
                  <span class="pf-c-form__label-required" aria-hidden="true">
                    &#42;
                  </span>
                </label>
                <input
                  type="text"
                  id="name"
                  class="pf-c-form-control"
                  v-model="session.name"
                  required
                  v-bind:aria-invalid="this.session.name.length == 0"
                />
              </div>
              <div class="pf-c-form__group">
                <label
                  class="pf-c-form__label"
                  for="help-text-simple-form-name"
                >
                  <span class="pf-c-form__label-text">Date</span>
                  <span class="pf-c-form__label-required" aria-hidden="true">
                    &#42;
                  </span>
                </label>
                <input
                  type="date"
                  id="date"
                  class="pf-c-form-control"
                  v-model="session.date"
                  required
                  v-bind:aria-invalid="this.session.date.length == 0"
                />
              </div>
              <div class="pf-c-form__group pf-m-action pf-c-pagination">
                <div class="pf-c-form__actions">
                  <button
                    type="submit"
                    id="updateSession"
                    class="pf-c-button pf-m-primary"
                  >
                    Save
                  </button>
                  <button
                    type="button"
                    @click="deleteSession"
                    id="deleteSession"
                    class="pf-c-button pf-m-danger"
                  >
                    Delete
                  </button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </section>
    <Modal
      id="message"
      name="message"
      v-show="isModalVisible"
      @close="closeModal"
    >
      <h1 class="pf-c-title pf-m-2xl" id="modal-title">
        Take turns says
      </h1>
      <div class="pf-c-modal-box__body" id="modal-description">
        <div id="save-message" v-if="error.length == 0 && action == 'update'">
          <strong>Wonderful!</strong> Your session was updated.
        </div>
        <div id="save-message" v-if="error.length == 0 && action == 'deleting'">
          <strong>Stop there!</strong> Are you sure to delete this session?
        </div>
        <div id="save-message" v-if="error.length == 0 && action == 'deleted'">
          <strong>Ok!</strong> The session was deleted.
        </div>
        <div id="error-message" v-if="error.length > 0 && action != ''">
          <strong>I'm sorry!</strong>
          But we has an error trying to do the action, please try again later.
        </div>
        <div
          id="loading"
          class="pf-u-text-align-center"
          v-if="error.length == 0 && action == ''"
        >
          <span
            class="pf-c-spinner"
            role="progressbar"
            aria-valuetext="Loading..."
          >
            <span class="pf-c-spinner__clipper"></span>
            <span class="pf-c-spinner__lead-ball"></span>
            <span class="pf-c-spinner__tail-ball"></span>
          </span>
          <span class="pf-u-display-block pf-u-text-align-center">
            We are working for you, wait please ...
          </span>
        </div>
      </div>
      <footer
        class="pf-c-modal-box__footer pf-m-align-right"
        v-if="error.length == 0 || action == ''"
      >
        <router-link
          id="ok-button"
          to="/"
          class="pf-c-button pf-m-primary"
          type="button"
          v-if="action != 'deleting' && action != ''"
        >
          Ok! thanks
        </router-link>
        <button
          type="button"
          @click="finishDeletion"
          id="startDeletion"
          class="pf-c-button pf-m-danger"
          v-if="action == 'deleting'"
        >
          Yes! go ahead
        </button>
        <button
          type="button"
          @click="closeModal"
          id="cancelDeletion"
          class="pf-c-button pf-m-primary"
          v-if="action == 'deleting'"
        >
          Cancel
        </button>
      </footer>
    </Modal>
  </main>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import Modal from "../components/Modal.vue";
import Session from "../types/session";
import axios from "axios";

@Component({
  components: { Modal }
})
export default class SessionDetails extends Vue {
  private apiUrl: string = process.env.VUE_APP_API_URL;
  private isModalVisible = true;
  private formSubmitted = false;
  private action = "";
  private error: string[] = [];
  private session: Session = {
    id: "",
    name: "",
    date: "",
    status: ""
  };

  mounted() {
    axios
      .get<Session>(`${this.apiUrl}/api/session/${this.$route.params.id}`)
      .then(response => {
        this.session = response.data;
        this.isModalVisible = false;
      })
      .catch(error => {
        this.error.push(error.message);
      });
  }

  private save(event: Event): void {
    event.preventDefault();
    this.action = "";
    this.isModalVisible = true;
    this.formSubmitted = true;
    axios
      .put(`${this.apiUrl}/api/session/${this.session.id}`, this.session)
      .then(() => {
        this.action = "update";
      })
      .catch(error => {
        this.error.push(error.message);
        this.isModalVisible = true;
      });
  }

  private deleteSession(): void {
    this.action = "deleting";
    this.isModalVisible = true;
  }

  private finishDeletion(): void {
    axios
      .delete(`${this.apiUrl}/api/session/${this.session.id}`)
      .then(() => {
        this.session = {
          id: "",
          name: "",
          date: "",
          status: ""
        };
        this.action = "deleted";
      })
      .catch(error => {
        this.error.push(error.message);
        this.isModalVisible = true;
      });
  }

  private closeModal(): void {
    this.action = "";
    this.isModalVisible = false;
  }
}
</script>
